package com.logicbig.example;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.Query;
import java.util.Arrays;
import java.util.List;

public class Main {
    private static final EntityManagerFactory emf =
            Persistence.createEntityManagerFactory(
                    "testPersistenceUnit");
    private static final EntityManager entityManager = emf.createEntityManager();

    public static void main(String[] args) {
        runNativeQuery("SHOW TABLES");
        runNativeQuery("SHOW COLUMNS from ExampleEntity");

        //creating and persisting
        MySerializableObject myObject = new MySerializableObject();
        myObject.setMyString("a test string");

        ExampleEntity entity = new ExampleEntity();
        entity.setId(1);
        entity.setMySerializableObject(myObject);

        entityManager.getTransaction().begin();
        entityManager.persist(entity);
        entityManager.getTransaction().commit();

        //it will show binary format of the persisted entity
        runNativeQuery("select * from ExampleEntity");

        System.out.println("finding entity:");
        ExampleEntity entity1 = entityManager.find(ExampleEntity.class, 1);
        System.out.println(entity1);
    }

    private static void runNativeQuery(String s) {
        System.out.println("--------\n" + s);
        Query query = entityManager.createNativeQuery(s);
        List list = query.getResultList();
        for (Object o : list) {
            System.out.println(Arrays.toString((Object[]) o));
        }
    }
}